Unit tammgc_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes_p, AMMGC_p;

function tammgc: String;

implementation

function tammgc: String;
var
M,N,MM,NN,I,J,JI,JJ,II,IERR :Integer;
NLEAD :Array [0..3] of Integer;
B :Array [0..31] of Complex;
const
A :Array [0..15] of Complex = ( ( re:7.9; im: 0.0 ),( re:8.5; im: 0.0 ),( 
re:4.3; im: 0.0 ),( re:3.2; im: 0.0 ),( re:5.6; 
im: 0.0 ),( re:-4.8; im: 0.0 ),( re:4.2; im: 0.0 )
,( re:-1.4; im: 0.0 ),( re:5.7; im: 0.0 ),( 
re:0.8; im: 0.0 ),( re:-3.2; im: 0.0 ),( re:-8.9; 
im: 0.0 ),( re:-7.2; im: 0.0 ),( re:3.5; im: 0.0 )
,( re:9.3; im: 0.0 ),( re:3.3; im:  0.0 ) );
label
_1,_2;
begin
Result := '';  {   }
M := 4;
N := M;
MM := M;
NN := 8;
for I:=1 to 4 do
 begin
  for J:=1 to 4 do
   begin
    B[(I-1)+(J-1)*4] := A[(I-1)+(J-1)*4];
    B[(I-1)+(J+4-1)*4] := A[(I-1)+(J-1)*4];
_1:
   end;
_2:
 end;
Result := Result + #$0D#$0A;
Result := Result + Format('%s',['  A=' + #$0D#$0A]);
for I:=1 to M do
 begin
  for J:=1 to N do
   begin
    Result := Result + Format(' %20.16f  %20.16f ',
 [A[(I-1)+(J-1)*4].re,A[(I-1)+(J-1)*4].im]) + #$0D#$0A;
   end;
 end;
Result := Result + #$0D#$0A;
AMMGC(A,M,N,NLEAD,B,MM,NN,IERR);
Result := Result + #$0D#$0A;
Result := Result + Format('%s',['    NLEAD=' + #$0D#$0A]);
for JI:=1 to N do
 begin
  Result := Result + Format('   %3d ',[NLEAD[JI-1]]) + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
Result := Result + #$0D#$0A;
Result := Result + Format('%s',['  A=' + #$0D#$0A]);
for II:=1 to M do
 begin
  for JJ:=1 to N do
   begin
    Result := Result + Format(' %20.16f  %20.16f ',
 [A[(II-1)+(JJ-1)*4].re,A[(II-1)+(JJ-1)*4].im]) + #$0D#$0A;
   end;
 end;
Result := Result + #$0D#$0A;
Result := Result + Format('%s',['   IERR=']);
Result := Result + Format('%3d ',[IERR]) + #$0D#$0A;
Result := Result + #$0D#$0A;
Result := Result + Format('%s',['  B=' + #$0D#$0A]);
for I:=1 to MM do
 begin
  for J:=1 to NN do
   begin
    Result := Result + Format(' %20.16f  %20.16f ',
 [B[(I-1)+(J-1)*4].re,B[(I-1)+(J-1)*4].im]) + #$0D#$0A;
   end;
 end;
Result := Result + #$0D#$0A;
UtRes('tammgc',Result);  {     tammgc.res }
exit;
end;

end.
